/*
 *   LADCCA
 *    
 *   Copyright (C) 2002 Robert Ham (node@users.sourceforge.net)
 *    
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __LADCCAD_CONN_H__
#define __LADCCAD_CONN_H__

#include <uuid/uuid.h>

#include <ladcca/ladcca.h>

typedef struct _conn conn_t;

struct _conn
{
  unsigned long         id;
  int                   socket;
  struct sockaddr_in    addr;
  
  pthread_mutex_t       lock;
};

void conn_init (conn_t * conn);
void conn_free (conn_t * conn);

conn_t * conn_new     ();
void     conn_destroy (conn_t *);

/*void conn_set_id        (conn_t * conn, unsigned long id);*/
void conn_set_socket    (conn_t * conn, int socket);
void conn_set_addr      (conn_t * conn, const struct sockaddr_in * addr);

void conn_lock (conn_t * conn);
void conn_unlock (conn_t * conn);

unsigned long              conn_get_id                (conn_t * conn);
int                        conn_get_socket            (conn_t * conn);
const struct sockaddr_in * conn_get_addr              (conn_t * conn);

const char * conn_get_ip     (conn_t *);
int          conn_get_port   (conn_t *);
const char * conn_get_str_id (conn_t *);



#endif /* __LADCCAD_CONN_H__ */
